# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import typing_extensions
from ..types.file_kind import FileKind


class FileParams(typing_extensions.TypedDict):
    id: str
    """
    Unique identifier for the file.
    """

    media_id: str
    """
    Identifier for the parent media object.
    """

    object: str
    """
    Object type, typically 'source' or 'derivative'.
    """

    kind: FileKind
    """
    The general type of media.
    """

    format: str
    """
    Specific file format/codec.
    """

    type: str
    """
    MIME type.
    """

    width: typing_extensions.NotRequired[int]
    """
    Width in pixels (for image/video).
    """

    height: typing_extensions.NotRequired[int]
    """
    Height in pixels (for image/video).
    """

    duration: typing_extensions.NotRequired[float]
    """
    Duration in seconds (for audio/video).
    """

    fps: typing_extensions.NotRequired[float]
    """
    Frames per second (for video).
    """

    filesize: int
    """
    File size in bytes.
    """

    folder: typing_extensions.NotRequired[str]
    """
    The folder path where the file is stored.
    """

    filename: str
    """
    The name of the file.
    """

    url: str
    """
    Publicly accessible URL for the file.
    """

    created_by: typing_extensions.NotRequired[str]
    """
    ID of the entity (e.g., task, user) that created this file.
    """

    created: dt.datetime
    """
    Timestamp when the file record was created.
    """

    updated: dt.datetime
    """
    Timestamp when the file record was last updated.
    """

    metadata: typing_extensions.NotRequired[typing.Dict[str, typing.Optional[typing.Any]]]
    """
    User-defined key-value metadata.
    """

    analysis: typing_extensions.NotRequired[typing.Dict[str, typing.Optional[typing.Any]]]
    """
    System-generated analysis data.
    """

    original: typing_extensions.NotRequired[bool]
    """
    Indicates if this is the originally uploaded file.
    """
