# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import typing_extensions
from ..types.media_kind import MediaKind
from ..types.media_status import MediaStatus
from .media_source import MediaSourceParams


class MediaParams(typing_extensions.TypedDict):
    id: str
    """
    Unique identifier for the media item.
    """

    object: str
    """
    Object type, always 'media'.
    """

    org_id: str
    """
    Organisation ID associated with the request.
    """

    project_id: str
    """
    Project ID associated with the request.
    """

    live_mode: bool
    """
    Indicates if the item is in live mode.
    """

    kind: MediaKind
    """
    The primary kind of the media item, derived from its sources.
    """

    type: str
    """
    The primary MIME type of the media item.
    """

    width: typing_extensions.NotRequired[int]
    """
    Width of the primary source in pixels.
    """

    height: typing_extensions.NotRequired[int]
    """
    Height of the primary source in pixels.
    """

    duration: typing_extensions.NotRequired[float]
    """
    Duration of the primary source in seconds.
    """

    filesize: typing_extensions.NotRequired[int]
    """
    Combined file size of all sources in bytes.
    """

    sources: typing.Sequence[MediaSourceParams]
    """
    Array of source files associated with this media item.
    """

    tracks: typing_extensions.NotRequired[typing.Sequence[typing.Dict[str, typing.Optional[typing.Any]]]]
    """
    Text tracks (e.g., subtitles, captions).
    """

    intelligence: typing_extensions.NotRequired[typing.Sequence[typing.Dict[str, typing.Optional[typing.Any]]]]
    """
    AI-generated analysis data.
    """

    original: str
    """
    URL of the primary original source file.
    """

    placeholder: typing_extensions.NotRequired[str]
    """
    Low-quality image placeholder (data URI).
    """

    background: typing_extensions.NotRequired[str]
    """
    Dominant background color hex code.
    """

    folder: typing_extensions.NotRequired[str]
    """
    The folder path containing the primary source file.
    """

    filename: typing_extensions.NotRequired[str]
    """
    The filename of the primary source file.
    """

    metadata: typing_extensions.NotRequired[typing.Dict[str, typing.Optional[typing.Any]]]
    """
    User-defined key-value metadata for the media item.
    """

    created: dt.datetime
    """
    Timestamp when the media record was created.
    """

    updated: dt.datetime
    """
    Timestamp when the media item was last updated.
    """

    status: MediaStatus
    """
    Processing status.
    """
