# This file was auto-generated by Fern from our API Definition.

import datetime as dt

import typing_extensions
from ..types.media_source_kind import MediaSourceKind
from ..types.media_source_orientation import MediaSourceOrientation


class MediaSourceParams(typing_extensions.TypedDict):
    """
    Represents a source file associated with a media item.
    """

    id: str
    """
    Unique identifier for the source file.
    """

    object: str
    """
    Object type, always 'source' for media sources.
    """

    kind: MediaSourceKind
    """
    The general type of media (e.g., video, image).
    """

    format: str
    """
    Specific file format (e.g., mp4, webm, jpg).
    """

    type: str
    """
    MIME type, potentially including codec info.
    """

    container: typing_extensions.NotRequired[str]
    """
    File container format.
    """

    codec: typing_extensions.NotRequired[str]
    """
    Primary codec.
    """

    width: typing_extensions.NotRequired[int]
    """
    Width in pixels.
    """

    height: typing_extensions.NotRequired[int]
    """
    Height in pixels.
    """

    orientation: typing_extensions.NotRequired[MediaSourceOrientation]
    """
    Visual orientation.
    """

    duration: typing_extensions.NotRequired[float]
    """
    Duration in seconds.
    """

    fps: typing_extensions.NotRequired[float]
    """
    Frames per second.
    """

    filesize: int
    """
    Source file size in bytes.
    """

    bitrate: typing_extensions.NotRequired[int]
    """
    Average bitrate in bits per second.
    """

    original: bool
    """
    Is this the originally ingested file?
    """

    label: typing_extensions.NotRequired[str]
    """
    User-defined label for this source.
    """

    src: str
    """
    URL of the source file.
    """

    folder: typing_extensions.NotRequired[str]
    """
    The folder path.
    """

    filename: str
    """
    The filename of the source file.
    """

    created: dt.datetime
    """
    Timestamp created.
    """

    updated: dt.datetime
    """
    Timestamp updated.
    """
