# This file was auto-generated by Fern from our API Definition.

from __future__ import annotations

import datetime as dt
import typing

import typing_extensions
from ..types.task_kind import TaskKind
from ..types.task_status import TaskStatus
from .task_results import TaskResultsParams


class TaskParams(typing_extensions.TypedDict):
    id: str
    """
    Unique identifier for the task.
    """

    object: str
    """
    Object type, always 'task'.
    """

    kind: TaskKind
    """
    The type of operation the task performs.
    """

    input: typing_extensions.NotRequired[typing.Dict[str, typing.Optional[typing.Any]]]
    """
    The input source for the task (e.g., details of a file). Structure varies based on the task kind and preceding steps.
    """

    options: typing_extensions.NotRequired[typing.Dict[str, typing.Optional[typing.Any]]]
    """
    Configuration options specific to the task kind.
    """

    output: typing_extensions.NotRequired[typing.Dict[str, typing.Optional[typing.Any]]]
    """
    The result generated by the task (e.g., details of an output file or intelligence data). Structure varies.
    """

    status: TaskStatus
    """
    Current status of the task.
    """

    progress: typing_extensions.NotRequired[int]
    """
    Task progress percentage.
    """

    error: typing_extensions.NotRequired[str]
    """
    Error message if the task failed.
    """

    created_by: typing_extensions.NotRequired[str]
    """
    ID of the entity that created the task (e.g., user ID, automation ID).
    """

    created: dt.datetime
    """
    Timestamp when the task was created.
    """

    updated: dt.datetime
    """
    Timestamp when the task was last updated.
    """

    parent_id: typing_extensions.NotRequired[str]
    """
    ID of the parent task if this is part of a workflow.
    """

    workflow: typing_extensions.NotRequired[typing.Sequence["TaskParams"]]
    """
    Array of nested task objects representing the steps within this workflow task.
    """

    next: typing_extensions.NotRequired[typing.Sequence["TaskParams"]]
    """
    Array representing subsequent tasks (e.g., in an automation). Structure may vary.
    """

    results: typing_extensions.NotRequired[TaskResultsParams]
