# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2
from ..core.unchecked_base_model import UncheckedBaseModel


class Signature(UncheckedBaseModel):
    domain: str = pydantic.Field()
    """
    Domain of the signed URL
    """

    filename: str = pydantic.Field()
    """
    Filename of the signed file
    """

    folder: typing.Optional[str] = pydantic.Field(default=None)
    """
    Folder of the signed file
    """

    expiry: int = pydantic.Field()
    """
    Expiry timestamp of the signed URL
    """

    method: str = pydantic.Field()
    """
    HTTP method for the signed URL
    """

    signature: str = pydantic.Field()
    """
    Generated signature for the signed URL
    """

    url: str = pydantic.Field()
    """
    Generated signed URL
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
